#define lastMenu 5
#define apMenuRes 1
#define fiMenuRes 256
#define edMenuRes 257
#define wiMenuRes 258
#define abMenuRes 259
#define apMenu 0
#define fiMenu 1
#define edMenu 2
#define wiMenu 3
#define abMenu 4

#define lastWindow 4
#define coWindow 0
#define grWindow 1
#define prWindow 2
#define edWindow 3
#define edWndRes 250
#define prWndRes 251
#define grWndRes 252
#define coWndRes 253
#define windowWidth 500
#define windowHeight 300
#define grXMin 70
#define grXMax 450
#define grYMin  250
#define grYMax 20

#define quitAlertRes 260

#define maxCoChars 28000

#define maxVars		80
#define maxLoops	10
#define maxMem		200
#define cmdWordLen	80
#define numCmdWds	6
#define stackLen 	10
#define maxLabels 	100


typedef char cmdWS[cmdWordLen];

typedef char colStr[12];
struct headerRec {
	cmdWS title;
	int interpolated, rows, cols, maxRows, maxCols;
	float start, samp;
	colStr colName[32];
	char hEndArray[30]; /*fills out header to 512 bytes*/
	};
typedef struct headerRec headerRec;

typedef float TArray[];
typedef TArray *TArrayPtr;
typedef TArrayPtr *TArrayHdl;

struct tableRec {
	headerRec header;
	TArrayHdl ptr[32];
	};
typedef struct tableRec tableRec;


struct macVarsRec	{
	cmdWS inStr[maxVars];
	cmdWS outStr[maxVars];
	int numVars;
	};
typedef struct macVarsRec macVarsRec;

struct commandRec {
	cmdWS cmdStr;
	cmdWS cmdWord[numCmdWds];
	};
typedef struct commandRec commandRec;

struct memRec {
	int active;
	int stack[stackLen];
	int stackPtr;
	int labels[maxLabels];
	int numLabels;
	};
typedef struct memRec memRec;

struct loopRec {
	int numLoops;
	int lineNum[maxLoops];
	cmdWS varName[maxLoops];
	int endValue[maxLoops];
	int increment[maxLoops];
	};
typedef struct loopRec loopRec;

struct graphRec {
	float xMin, xMax, yMin, yMax;
	};
typedef struct graphRec graphRec;

struct tabEdRec {
	Rect row[19], name[4], entry[19][4];
	int activeEntry, activeName, r, c;
	};
typedef struct tabEdRec tabEdRec;


MenuHandle		myMenu[lastMenu];
Rect			dragRect, pRect, growRect, abortRect, wayOffScreen;
EventRecord		myEvent;
int 			refNum, MyControl, doneFlag, frontFlag, pendingFlag, currentWindow;
int			scale, code, topPixel[lastWindow], leftPixel[lastWindow], nCoeffs, scrapIndex;
WindowRecord		wRecord[lastWindow];
WindowPtr		theWindow[lastWindow], whichWindow;
ControlHandle		hScroll[lastWindow], vScroll[lastWindow], whichControl;
Point			theOrigin[lastWindow];
RgnHandle		theUpdateRgn;
BitMap			grMap;
GrafPtr			grPortPtr, oldPort;
GrafPort		grPort;
TEHandle		coText, prText, edText;
jmp_buf			envbuf;
macVarsRec		macVars;
commandRec 		command;
cmdWS			cmdWord0;
float 			infinity, minfinity, coeffs[33];
tableRec 		table;
memRec			mem;
loopRec 		loops;
graphRec		graph;
char			pentName[cmdWordLen];
tabEdRec		tabEd;

char			noSuchModifier[] = "no such modifier";
char			badModifier[] = "bad modifier";
char			noSuchColumn[] = "no such column";
char			noSuchRow[] = "no such row";
